import MarkdownIt from "markdown-it";
import MarkdownItWikilinks2 from "./wikilinks2";
import MarkdownItMetadata from "./metadatalinks";
import MarkdownItMark from "markdown-it-mark";
import MarkdownItKatex from "markdown-it-katex";
import MarkdownItTag from "./markdown-tag";

const MD = new MarkdownIt({
    linkify: true,
    highlight: function (str, lang) {
        if (lang === 'mermaid') {
            return '<div class="mermaid">' + str + '</div>';
        }
        return '';
    }
})
MD.use(MarkdownItWikilinks2({
    baseURL: document.querySelector('body').dataset.baseUrl,
    uriSuffix: '',
    relativeBaseURL: '/edit/',
    htmlAttributes: {
        class: 'wiki-link'
    },
}))
MD.use(MarkdownItMetadata())
// MD.use(MarkdownItWikilinks({
//     baseURL: document.querySelector('body').dataset.baseUrl,
//     uriSuffix: '',
//     relativeBaseURL: '/edit/',
//     htmlAttributes: {
//         class: 'wiki-link'
//     },
// }))
MD.use(MarkdownItMark).use(MarkdownItKatex)
MD.use(MarkdownItTag({
    relativeBaseURL: '/edit/',
}))

export default MD;
